﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.OpenAccess;
using Telerik.OpenAccess.Query;
using OpenAccessData;
using Telerik.Web.UI;

namespace CarRentWebSite
{
    public partial class BookACar : System.Web.UI.Page
    {
        private IObjectScope cachedScope;
        private CarRentMaster scopeHolder;
        protected void Page_Init(object sender, EventArgs e)
        {
            scopeHolder = (CarRentMaster)this.Master;
            cachedScope = scopeHolder.Scope;
        }
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected void RadGrid1_SelectedIndexChanged(object sender, EventArgs e)
        {
            RadTextBox1.Visible = true;
            RadTextBox2.Visible = true;
            int carId = Int32.Parse(RadGrid1.SelectedValue.ToString());
            var result = from c in cachedScope.Extent<Car>() where c.CarID == carId select c;
            RadTextBox1.Text = result.First().Model.ToString();
            RadTextBox2.Text = result.First().Make.ToString();
            Names.Visible = true;
            Address.Visible = true;
            ZIP.Visible = true;
            Country.Visible = true;
            City.Visible = true;
            State.Visible = true;
            DrivingLicense.Visible = true;
            Button1.Visible = true;
            lable3.Visible = true;
            StartDate.Visible = true;
            EndDate.Visible = true;
            Lable1.Visible = true;
            lable2.Visible = true;
            
        }

        protected void Button1_Click(object sender, EventArgs e)
        {
            int carID = Int32.Parse(RadGrid1.SelectedValue.ToString());
            DateTime dateToCompare = DateTime.Parse(StartDate.Text);
            var rentalResult = (from c in cachedScope.Extent<RentalOrder>() where c.Car.CarID == carID select c).ToList();
            foreach (RentalOrder rt in rentalResult)
            {
                if (((dateToCompare.CompareTo(rt.RentEndDate) < 0) && (dateToCompare.CompareTo(rt.RentStartDate) > 0)))
                {
                    Response.Redirect("/ErrorPage.aspx");
                }
            }


            {
                
                Customer cst = new Customer();
                cst.Address = Address.Text;
                cst.City = City.Text;
                cst.Country = Country.Text;
                cst.DrvLicNumber = DrivingLicense.Text;
                cst.FullName = Names.Text;
                cst.State = State.Text;
                cst.ZIPCode = ZIP.Text;
                Car myCar = new Car();
                myCar = (from c in cachedScope.Extent<Car>() where c.CarID == carID select c).First();
                RentalOrder rtl = new RentalOrder();
                rtl.DateProcessed = DateTime.Today;
                rtl.Car = myCar;
                rtl.Customer = cst;
                rtl.Employee = (from c in cachedScope.Extent<Employee>() where c.FirstName.Contains("Internet") select c).First();
                if (rtl.Employee == null)
                {
                    rtl.Employee = (from c in cachedScope.Extent<Employee>() select c).First();
                }
                rtl.TankLevel = "full";
                rtl.RentStartDate = DateTime.Parse(StartDate.Text);
                rtl.RentEndDate = DateTime.Parse(EndDate.Text);
                TimeSpan date = DateTime.Parse(EndDate.Text).Subtract(DateTime.Parse(StartDate.Text));
                double days = date.TotalDays;
                decimal? result;
                if (days == 1)
                {
                    result = (from c in cachedScope.Extent<RentalRate>() where myCar.Category == c.Category select c.Daily).First();
                }
                else if (days > 7)
                {
                    result = (from c in cachedScope.Extent<RentalRate>() where myCar.Category == c.Category select c.Monthly).First();
                }
                else
                {
                    result = (from c in cachedScope.Extent<RentalRate>() where myCar.Category == c.Category select c.Weekly).First();
                }
                rtl.RateApplied = result;
                cachedScope.Transaction.Begin();
                cachedScope.Add(cst);
                cachedScope.Add(rtl);
                cachedScope.Transaction.Commit();
                Response.Redirect("/OrderCompleted.aspx");
            }


        }

        
        

       

       
    }
}
