﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using Telerik.OpenAccess;
using OpenAccessData;

namespace CarRentWebSite
{
    /// <summary>
    /// Summary description for CarRentalAdministratorService
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    // [System.Web.Script.Services.ScriptService]
    public class CarRentalAdministratorService : System.Web.Services.WebService
    {

        [WebMethod]
        public Telerik.OpenAccess.ObjectContainer.ChangeSet GetAllCars()
        {

            ObjectContainer.ChangeSet ccData = null;
            IObjectScope os = ObjectScopeProvider1.GetNewObjectScope();

            os.Transaction.Begin();
            try
            {
                string resultName = "Cars";
                string query = "SELECT * FROM CarExtent AS x";
                IQuery qry = os.GetOqlQuery(query);
                IQueryResult qres = qry.Execute();

                ObjectContainer oc = new ObjectContainer();

                Telerik.OpenAccess.IObjectCollector objCollector =
                    new FetchGroupCollector(FetchGroupCollector.DefaultFetchGroup);

                if (qres != null)
                {
                    oc.CopyFrom(os, resultName, qres, objCollector);
                }
                else
                {
                    oc.CopyFrom(os, resultName, qres, null);

                }
                ccData = oc.GetContent();
            }
            finally
            {
                os.Transaction.Rollback();
                os.Dispose();
            }
            return ccData;
        }
        [WebMethod]
        public ObjectContainer.ChangeSet SyncCars(ObjectContainer.ChangeSet changes)
        {
            try
            {
                ObjectContainer.ChangeSet ccData = null;
                IObjectScope os = ObjectScopeProvider1.GetNewObjectScope();
                try
                {
                    ccData = ObjectContainer.CommitChanges(changes, Telerik.OpenAccess.ObjectContainer.Verify.Changed, os, true, true);
                }
                finally
                {
                    os.Dispose();
                }
                return ccData;
            }
            catch (Exception exc)
            {
                string msg = exc.Message;
                throw exc;
            }
        }

    }

}
